<?php

namespace bhr\Admin\Controller;

if(!defined('ABSPATH')) exit;

use bhr\Admin\Model\AdminModel;
use bhr\Admin\Entity\MessageEntity;

use SALESmanago\Entity\Configuration;
use SALESmanago\Entity\User;
use SALESmanago\Exception\Exception;
use \SALESmanago\Controller\LoginController as SMLoginController;
use SALESmanago\Services\UserAccountService;

class LoginController
{
    private $AdminModel;

    public function __construct(AdminModel $AdminModel)
    {
        $this->AdminModel = $AdminModel;
    }

    /**
     * @param array $request
     */
    public function loginUser($request)
    {
        try {
            $User = new User();
            $User
                ->setEmail($request['username'])
                ->setPass($request['password']);

            $Configuration = Configuration::getInstance();
            if (isset($request['endpoint']) && !empty($request['endpoint'])) {
                $Configuration->setEndpoint($request['endpoint']);
            }
        } catch (\Exception $e) {
            MessageEntity::getInstance()->addException(new Exception($e->getMessage(), 103));
        }
        try {
            $LoginController = new SMLoginController($Configuration);
            $Response = $LoginController->login($User);
        } catch (Exception $e) {
            MessageEntity::getInstance()->addException($e);
        } catch (\Exception $e) {
            MessageEntity::getInstance()->addException(new Exception($e->getMessage(), 104));
        }
        if (!empty($Response) && $Response->getStatus() == true) {
            $this->AdminModel->saveConfiguration();
            MessageEntity::getInstance()->addMessage(__('Logged in.', 'salesmanago'), 'success', 701);
        } elseif (!empty($Response)) {
            MessageEntity::getInstance()->addMessage($Response->getMessage(), 'error', 105);
        }
    }

    /**
     *
     */
    public function logoutUser()
    {
        try{
            $this->AdminModel->removeSettingsOnLogout();
            $_COOKIE['sm_logged_in'] = null;
            unset($_COOKIE['sm_logged_in']);
        } catch (\Exception $e) {
            MessageEntity::getInstance()->addException(new Exception($e->getMessage(), 151));
            header('Location: admin.php?page=' . SALESMANAGO . '&message=logout-error');
            return;
        }
        header('Location: admin.php?page=' . SALESMANAGO . '&message=logout');
    }
}