<?php

namespace bhr\Admin\Entity\Plugins;

if(!defined('ABSPATH')) exit;

use bhr\Admin\Entity\AbstractEntity;
use bhr\Admin\Entity\MessageEntity;
use bhr\Admin\Entity\Plugins\DoubleOptIn;
use \RGFormsModel;
use SALESmanago\Exception\Exception;

class Gf extends AbstractPlugin
{
    public static function listAvailableForms()
    {
        if(!class_exists('RGFormsModel')) {
            throw new Exception("Gravity Forms class not found", 672);
        } elseif(!method_exists('RGFormsModel', 'get_forms')) {
            throw new Exception("Gravity Forms class not found", 673);
        }
        $availableFormsList = array();
        try {
            if ($formsList = RGFormsModel::get_forms()) {
                foreach ($formsList as $form) {
                    $availableFormsList[$form->id] = $form->title;
                }
            }
        } catch (\Exception $e) {
            throw new Exception("Error on obtaining Gravity Forms list: " . print_r($e, true), 674);
        }
        return $availableFormsList;
    }

    public function setLegacyFormsGf($forms = array())
    {
        try {
            $availableFormsList = self::listAvailableForms();
        } catch (Exception $e) {
            MessageEntity::getInstance()->addException($e);
        }
        parent::setLegacyForms($forms, $availableFormsList);
        return $this;
    }
}