<div id="salesmanago-content">
    <form action="" method="post" enctype="application/x-www-form-urlencoded" id="salesmanago-conf">
        <h2><?php _e('General settings', 'salesmanago') ?></h2>

        <table class="form-table">
            <tbody>
            <tr valign="top">
                <th scope="row">
                    <label for="salesmanago-ignored-domains"><?php _e('Ignored domains', 'salesmanago') ?></label>
                </th>
                <td>
                    <input type="text" name="salesmanago-ignored-domains" value="<?php
                    $ignoredDomains = $this->AdminModel->getConfiguration()->getIgnoredDomains();
                    echo is_array($ignoredDomains) ? implode(', ', $ignoredDomains) : $ignoredDomains;
                    ?>" id="salesmanago-ignored-domains" class="regular-text">
                    <p class="description">
                        <?php _e('Separated with commas, for example: <b>10minutemail.net,temp-mail.com</b>', 'salesmanago') ?>
                    </p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">
                    <label for="salesmanago-cookie-ttl"><?php _e('Cookie lifetime', 'salesmanago') ?></label>
                </th>
                <td>
                    <select name="salesmanago-cookie-ttl" id="salesmanago-cookie-ttl">
                        <option value="0" <?php $this->selected("0", 'cookie-ttl') ?>>
                            <?php _e('Cart updates will always create new ext. events', 'salesmanago') ?>
                        </option>
                        <option value="900" <?php $this->selected("900", 'cookie-ttl') ?>>
                            <?php _e('15 min', 'salesmanago') ?>
                        </option>
                        <option value="3600" <?php $this->selected("3600", 'cookie-ttl') ?>>
                            <?php _e('1 h', 'salesmanago') ?>
                        </option>
                        <option value="14400" <?php $this->selected("14400", 'cookie-ttl') ?>>
                            <?php _e('4 h', 'salesmanago') ?>
                        </option>
                        <option value="43200" <?php $this->selected("43200", 'cookie-ttl') ?>>
                            <?php _e('12 h', 'salesmanago') ?>
                        </option>
                        <option value="604800" <?php $this->selected("604800", 'cookie-ttl') ?>>
                            <?php _e('7 days', 'salesmanago') ?>
                        </option>
                        <option value="-1" <?php $this->selected("-1", 'cookie-ttl') ?>>
                            <?php _e('Cart update will always update ext. events', 'salesmanago') ?>
                        </option>

                    </select>
                    <p class="description">
                        <?php _e('After this time, cart updates will be treated as new external events', 'salesmanago') ?>
                    </p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">
                    <label for="salesmanago-language-detection"><?php _e('Language detection method', 'salesmanago') ?></label>
                </th>
                <td>
                    <select name="language-detection" id="salesmanago-language-detection">
                        <option value="platform" <?php $this->selected('platform', 'language-detection') ?>>
                            <?php _e('Detected by WordPress', 'salesmanago') ?>
                        </option>
                        <option value="browser" <?php $this->selected('browser', 'language-detection') ?>>
                            <?php _e('Browser language', 'salesmanago') ?>
                        </option>


                    </select>
                    <p class="description">
                        <?php _e('Language is used when sending double opt-in confirmation emails. You can use language detected by WordPress or user\'s browser language', 'salesmanago') ?>
                    </p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row" class="titledesc">
                    <label for="salesmanago-disable-monitoring-code"><?php _e('Disable monitoring code', 'salesmanago') ?></label>
                </th>
                <td>
                    <input type="checkbox" name="disable-monitoring-code" <?php $this->selected('true', 'disable-monitoring-code') ?> value="1" id="salesmanago-disable-monitoring-code">
                    <label for="salesmanago-disable-monitoring-code">
                        <span><?php _e('Enable this option if you want to add monitoring code on your own', 'salesmanago') ?></span>
                    </label>
                </td>
            </tr>
            </tbody>
        </table>

        <?php
        include('partials/save.php');
        ?>
    </form>



</div>