document.addEventListener('DOMContentLoaded', appendSalesmanagoSubmenu, false);
function appendSalesmanagoSubmenu() {
	let menu = document.getElementById('adminmenu');
	if(!menu) {
		return;
	}
	let salesmanagoMenu = menu.getElementsByClassName('toplevel_page_salesmanago')[0];
	if(!salesmanagoMenu) {
		return;
	}
	let salesmanagoSubmenu = salesmanagoMenu.getElementsByClassName('wp-submenu')[0];
	if(!salesmanagoSubmenu) {
		return;
	}
	let salesmanagoLink = salesmanagoSubmenu.lastChild.children[0];
	if(!salesmanagoLink) {
		return;
	}
	salesmanagoLink.href = "https://www.salesmanago.com/login.htm";
	salesmanagoLink.target = "_blank";
}

function salesmanagoRemoveForm(id)
{
	let formTable = document.getElementById("salesmanago-form-"+id);
	if(!formTable) {
		return;
	}
	formTable.remove();
}

function salesmanagoToggleDoubleOptIn()
{
	let doubleOptInFields = document.getElementsByClassName("salesmanago-double-opt-in");
	let doubleOptInVisible = document.getElementById('double-opt-in-active').checked;
	for(let i=0; i<doubleOptInFields.length; i++) {
		doubleOptInFields[i].classList.toggle("hidden");
	}
}

function salesmanagoToggleEndpoint()
{
	let endpointField = document.getElementById("endpoint");
	let endpointVisible = document.getElementById('endpoint-active').checked;
	if(endpointVisible) {
			endpointField.classList.remove("hidden");
	} else {
			endpointField.classList.add("hidden");
	}
}

function salesmanagoChangeOptInInput()
{
	let mode = document.getElementById('salesmanago-opt-in-input-mode').value;
	document.getElementById('salesmanago-opt-in-input-map').classList.add('hidden');
	document.getElementById('salesmanago-opt-in-input-append').classList.add('hidden');
	document.getElementById('salesmanago-opt-in-input-append-info').classList.add('hidden');
	if(mode === 'map') {
		document.getElementById('salesmanago-opt-in-input-map').classList.remove('hidden');
	} else if (mode === 'append' || mode === 'appendEverywhere') {
		document.getElementById('salesmanago-opt-in-input-append').classList.remove('hidden');
		document.getElementById('salesmanago-opt-in-input-append-info').classList.remove('hidden');
	}
}

function salesmanagoExport()
{
	type 	= window.salesmanago.type;
	ajaxDir = window.salesmanago.ajaxDir;
	nonce 	= window.salesmanago.exportNonce;

	document.getElementById('salesmanago-export-forms').style.display = 'none';
	document.getElementById('salesmanago-export-notice').style.display = 'block';

	salesmanagoResetView();
	salesmanagoPrepareExport(salesmanagoExportPackage);

	return false;
}

function _t(text)
{
	return window.salesmanago.translations[text] ? window.salesmanago.translations[text] : text;

}

function salesmanagoPrepareExport(callback)
{
	type 	= window.salesmanago.type;
	ajaxDir = window.salesmanago.ajaxDir;
	nonce 	= window.salesmanago.exportNonce;

	var xhttp = new XMLHttpRequest();
	var formData = new FormData();
	formData.append('nonce', nonce);
	let data = '';
	if (type === 'contacts') {
		formData.append('action', 'salesmanago_export_count_contacts');
		data = btoa(JSON.stringify({
			dateFrom: document.getElementById('salesmanago-export-contacts-from').value,
			dateTo: document.getElementById('salesmanago-export-contacts-to').value,
			tags: document.getElementById('salesmanago-export-tags').value,
		}));
	} else if (type === 'events') {
		formData.append('action', 'salesmanago_export_count_events');
		data = btoa(JSON.stringify({
			dateFrom: document.getElementById('salesmanago-export-events-from').value,
			dateTo: document.getElementById('salesmanago-export-events-to').value,
		}));
	} else {
		console.log('wrong ' + type);
	}
	formData.append('data', data);

	xhttp.onreadystatechange = function () {
		if (this.readyState === 4 && this.status === 200) {
			window.localStorage.setItem('salesmanagoExport', this.responseText);
			salesmanagoUpdateView();
			callback();
		} else if (this.readyState === 4 && this.status !== 200) {
			salesmanagoHandleFailedExport(this);
		}
	};
	xhttp.open("POST", ajaxDir, true);
	xhttp.send(formData);
}

function salesmanagoHandleFailedExport(response)
{
	let exportStatus = {};
	if(window.localStorage.getItem('salesmanagoExport')) {
		exportStatus = JSON.parse(window.localStorage.getItem('salesmanagoExport'));
	}
	exportStatus.status = 'failed';
	exportStatus.message = 'Unhandled error. Refresh page to resume export. ';
	exportStatus.message += '\nTo debug this error you can edit wp-includes/load.php. Search for "XMLRPC_REQUEST" and change "display_errors" to 1.';
	exportStatus.message += '\nStatus: ' +  response.status;
	exportStatus.message += '\nStatusText: ' +  response.statusText;
	exportStatus.message += '\nResponseText: ' +  response.responseText;
	exportStatus.message += '\nResponseURL: ' +  response.responseURL;
	exportStatus.message += '\nTimeout: ' +  response.timeout;

	let json = JSON.stringify(exportStatus);

	window.localStorage.setItem('salesmanagoExport', json);
	salesmanagoUpdateView();
}

function salesmanagoExportPackage()
{
	type 	= window.salesmanago.type;
	ajaxDir = window.salesmanago.ajaxDir;
	nonce 	= window.salesmanago.exportNonce;

	var xhttp = new XMLHttpRequest();
	var formData = new FormData();
	if (type === 'contacts') {
		formData.append('action', 'salesmanago_export_contacts');
	} else if (type === 'events') {
		formData.append('action', 'salesmanago_export_events');
	} else {
		console.log('wrong ' + type);
	}
	formData.append('data', btoa(window.localStorage.getItem('salesmanagoExport'), true));
	xhttp.onreadystatechange = function () {
		if (this.readyState === 4 && this.status === 200) {
			window.localStorage.setItem('salesmanagoExport', this.responseText);

			salesmanagoUpdateView();

			let exportStatus = JSON.parse(window.localStorage.getItem('salesmanagoExport'));
			if (exportStatus.status === "in_progress" || exportStatus.status === "last_check") {
				salesmanagoExportPackage();
			} else {
				salesmanagoExportDone();
			}

		} else if (this.readyState === 4 && this.status !== 200) {
			salesmanagoHandleFailedExport(this);
		}
	};
	xhttp.open("POST", ajaxDir, true);
	xhttp.send(formData);
}

function salesmanagoExportDone()
{
	salesmanagoUpdateView();
}

function salesmanagoUpdateView()
{
	type 	= window.salesmanago.type;
	ajaxDir = window.salesmanago.ajaxDir;
	nonce 	= window.salesmanago.exportNonce;

	let exportStatus = JSON.parse(window.localStorage.getItem('salesmanagoExport'));
	if(!exportStatus) {
		return;
	}
	document.getElementById("salesmanago-export-status").innerHTML = _t(exportStatus.status);

	if (exportStatus.status === "in_progress" || exportStatus.status === "last_check") {
		salesmanagoSetNoticeType('notice-info');
		let percentage = Math.round(100 * (exportStatus.lastExportedPackage + 1) / (exportStatus.packageCount));
		document.getElementById('salesmanago-export-progress').value = percentage;
		if (exportStatus.status === "in_progress") {
			document.getElementById("salesmanago-export-status").innerHTML += " (" + percentage + "%)";
		}
	} else if (exportStatus.status === "done") {
		salesmanagoSetNoticeType('notice-success');
		document.getElementById('salesmanago-export-forms').style.display = "block";
	} else if (exportStatus.status === "failed") {
		salesmanagoSetNoticeType('notice-error');
		if (exportStatus.message) {
			console.log(exportStatus.message);
		}
	} else if (exportStatus.status !== "preparing") {
		salesmanagoSetNoticeType('notice-error');
	}
	//console.log(exportStatus);
}

function salesmanagoResetView()
{
	document.getElementById('salesmanago-export-forms').style.display = 'none';
	document.getElementById('salesmanago-export-restore').style.display = 'none';
	document.getElementById('salesmanago-export-notice').style.display = 'block';
	document.getElementById("salesmanago-export-status").innerHTML = _t("starting");
	document.getElementById('salesmanago-export-progress').value = 0;
	salesmanagoSetNoticeType('notice-info');

}

function salesmanagoSetNoticeType(type = 'notice-warning')
{
	let notice = document.getElementById('salesmanago-export-notice-type');
	notice.className = '';
	notice.classList.add('notice');
	notice.classList.add('inline');
	notice.classList.add(type);
	if(type === 'notice-success') {
		notice.classList.add('is-dismissible');
	}
}

function salesmanagoExportCheckIfInterrupted()
{
	if(!window.salesmanago || !window.salesmanago.isExportPage || !window.localStorage.getItem('salesmanagoExport')) {
		return;
	}
	let exportStatus = JSON.parse(window.localStorage.getItem('salesmanagoExport'));
	if(!exportStatus) {
		return;
	}
	if(exportStatus.status === 'in_progress'
		|| exportStatus.status === 'failed'
		|| exportStatus.status === 'unknown'
	) {
		document.getElementById('salesmanago-export-restore').style.display = 'block';

		let percentage = Math.round(100 * (exportStatus.lastExportedPackage + 1) / (exportStatus.packageCount));

		let details = document.getElementById('salesmanago-export-details').children[0];
		details.children[0].children[1].innerHTML = _t(exportStatus.type);
		details.children[1].children[1].innerHTML = timeConverter(exportStatus.started);
		details.children[2].children[1].innerHTML = timeConverter(exportStatus.lastSuccess);
		details.children[3].children[1].innerHTML = percentage+'%';
		details.children[4].children[1].innerHTML = exportStatus.tags;

	}
}
window.addEventListener('load', salesmanagoExportCheckIfInterrupted);

function salesmanagoContinueExport()
{
	salesmanagoResetView();

	let exportStatus = JSON.parse(window.localStorage.getItem('salesmanagoExport'));
	window.salesmanago.type = exportStatus.type;

	salesmanagoExportPackage();

	return false;
}

function timeConverter(UNIX_timestamp){
	let DateObject = new Date(UNIX_timestamp * 1000);
	let LocalTime = new Date(DateObject.setTime( DateObject.getTime() - DateObject.getTimezoneOffset()*60*1000 ));
	return LocalTime.toISOString().replace("T", ' ').replace(".000Z", '');
}

function salesmanagoExportContacts()
{
	window.localStorage.setItem('salesmanagoExport', null);

	window.salesmanago.type = 'contacts';
	salesmanagoExport();
	return false;
}

function salesmanagoExportEvents()
{
	window.localStorage.setItem('salesmanagoExport', null);

	window.salesmanago.type = 'events';
	salesmanagoExport();
	return false;
}

function salesmanagoPreventIncompleteDoubleOptIn()
{
	let field1 = document.getElementById("double-opt-in-template-id").value;
	let field2 = document.getElementById("double-opt-in-account-id").value;
	let field3 = document.getElementById("double-opt-in-subject").value;
	let validated = false;
	if(field1 === "" && field2 === "" && field3 === "") {
		validated = true;
	} else if(field1 !== "" && field2 !== "" && field3 !== "") {
		validated = true;
	}
	if(validated) {
		document.getElementById("salesmanago-double-opt-in-info").classList.add("hidden");
	} else {
		document.getElementById("salesmanago-double-opt-in-info").classList.remove("hidden");
	}
}

function salesmanagoTestCartRecovery(url)
{
	document.getElementById('salesmanago-cart-recovery-test').style.display = "table-row";
	let output = document.getElementById('salesmanago-cart-recovery-test-content');

	var xhttp = new XMLHttpRequest();
	xhttp.onreadystatechange = function () {
		if (this.readyState === 4 && this.status === 200) {
			output.innerHTML = this.responseText;
		} else if (this.readyState === 4 && this.status !== 200) {
			output.innerHTML =
				'<p style="color: #ff0000">' + _t('problem') + '</p><u>'
				+ url + "</u> " + _t('urlNotFound') + " " + this.status;
		} else if (this.readyState >= 1) {
			output.innerHTML = this.readyState + '/' + this.status
		}
	};
	xhttp.open("GET", url+'&test=1', true);
	xhttp.send();
}

function insertAfter(newNode, referenceNode) {
	referenceNode.parentNode.insertBefore(newNode, referenceNode.nextSibling);
}