<?php
/**
 * @var string $context = 'wc' from SettingsRenderer
 */

use bhr\Admin\Entity\MessageEntity;
use SALESmanago\Exception\Exception;

?>
<div id="salesmanago-content">
    <form action="" method="post" enctype="application/x-www-form-urlencoded" id="salesmanago-conf">
        <h2>
            <?php _e('Manage WooCommerce integration', 'salesmanago') ?>
        </h2>
        <div class="notice notice-info inline">
            <?php
                echo(__('You can allow customers to create new accounts.','salesmanago')
                . ' <a href="options-general.php">' . __('Manage options in WooCommerce settings', 'salesmanago') . '</a>.'
                ) ?>
        </div>
        <?php
            include(dirname(__FILE__).'/../partials/owner.php');
        ?>
        <h3><?php _e('Tags', 'salesmanago') ?></h3>
        <table class="form-table">
            <tr valign="top">
                <th scope="row">
                    <label for="salesmanago-tags-registration"><?php _e('Registration tags', 'salesmanago') ?></label>
                </th>
                <td>
                    <input
                            type="text"
                            name="tags[registration]"
                            value="<?php echo $this->AdminModel->getPlatformSettings()->getPluginWc()->getTagsByType("registration"); ?>"
                            id="salesmanago-tags-registration"
                            class="regular-text">
                    <p class="description">
                        <?php _e('Tags assigned after registration (separated with commas)', 'salesmanago') ?>
                    </p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">
                    <label for="salesmanago-tags-newsletter"><?php _e('Newsletter tags', 'salesmanago') ?></label>
                </th>
                <td>
                    <input
                            type="text"
                            name="tags[newsletter]"
                            value="<?php echo $this->AdminModel->getPlatformSettings()->getPluginWc()->getTagsByType("newsletter"); ?>"
                           id="salesmanago-tags-newsletter"
                           class="regular-text">
                    <p class="description">
                        <?php _e('Tags assigned after subscription to the newsletter (separated with commas)', 'salesmanago') ?>
                    </p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">
                    <label for="salesmanago-tags-login"><?php _e('Login tags', 'salesmanago') ?></label>
                </th>
                <td>
                    <input
                            type="text"
                            name="tags[login]"
                            value="<?php echo $this->AdminModel->getPlatformSettings()->getPluginWc()->getTagsByType("login"); ?>"
                            id="salesmanago-tags-login"
                            class="regular-text">
                    <p class="description">
                        <?php _e('Tags assigned after login (separated with commas)', 'salesmanago') ?>
                    </p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">
                    <label for="salesmanago-tags-purchase"><?php _e('Purchase tags', 'salesmanago') ?></label>
                </th>
                <td>
                    <input
                            type="text"
                            name="tags[purchase]"
                            value="<?php echo $this->AdminModel->getPlatformSettings()->getPluginWc()->getTagsByType("purchase"); ?>"
                           id="salesmanago-tags-purchase"
                           class="regular-text">
                    <p class="description">
                        <?php _e('Tags assigned after purchase (separated with commas)', 'salesmanago') ?>
                    </p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">
                    <label for="salesmanago-tags-guest-purchase"><?php _e('Guest purchase tags', 'salesmanago') ?></label>
                </th>
                <td>
                    <input
                            type="text"
                            name="tags[guestPurchase]"
                            value="<?php echo $this->AdminModel->getPlatformSettings()->getPluginWc()->getTagsByType("guestPurchase"); ?>"
                            id="salesmanago-tags-guest-purchase"
                            class="regular-text">
                    <p class="description">
                        <?php _e('Tags assigned after guest purchase (separated with commas)', 'salesmanago') ?>
                    </p>
                </td>
            </tr>
            </table>
            <?php
                include(dirname(__FILE__).'/../partials/double_opt_in.php');
                include(dirname(__FILE__).'/../partials/opt_in.php');
            ?>
            <h3><?php _e('Purchase hook', 'salesmanago') ?></h3>
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">
                        <label for="purchase-hook"><?php _e('Hook activating purchase event', 'salesmanago') ?></label>
                    </th>
                    <td>
                        <select name="purchase-hook" id="purchase-hook" class="regular-text">
                            <option <?php $this->selected('woocommerce_order_status_changed', 'purchase-hook', $context);?>>
                                woocommerce_order_status_changed
                            </option>
                            <option <?php $this->selected('woocommerce_checkout_order_processed', 'purchase-hook', $context); ?>>
                                woocommerce_checkout_order_processed
                            </option>
                            <option <?php $this->selected('woocommerce_checkout_update_order_meta', 'purchase-hook', $context);?>>
                                woocommerce_checkout_update_order_meta
                            </option>
                            <option <?php $this->selected('woocommerce_pre_payment_complete', 'purchase-hook', $context);?>>
                                woocommerce_pre_payment_complete
                            </option>
                            <option <?php $this->selected('woocommerce_payment_complete', 'purchase-hook', $context); ?>>
                                woocommerce_payment_complete
                            </option>
                        </select>
                        <p class="description">
                            <?php _e('If you use a custom payment method, the default hook might not work. You can try using a different one', 'salesmanago'); ?>
                        </p>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row" class="titledesc">
                        <label for="salesmanago-prevent-event-duplication"><?php _e('Prevent event duplication', 'salesmanago') ?></label>
                    </th>
                    <td>
                        <input type="checkbox" name="prevent-event-duplication" <?php $this->selected('true', 'prevent-event-duplication', $context) ?> value="1" id="salesmanago-prevent-event-duplication">
                        <label for="salesmanago-prevent-event-duplication">
                            <span><?php _e('Prevent duplication of PURCHASE events', 'salesmanago') ?></span>
                            <p class="description">
                                <?php _e('Enable this option to omit consecutive PURCHASE events (within 30 second)', 'salesmanago') ?>                            </p>
                        </label>
                    </td>
                </tr>
            </table>
        <h3><?php _e('Cart recovery', 'salesmanago') ?></h3>
        <table class="form-table">
            <tr valign="top">
                <th scope="row" class="titledesc">
                    <label><?php _e('Test cart recovery', 'salesmanago') ?></label>
                </th>
                <td>
                    <?php
                    $url = home_url().'?rest_route=/salesmanago/v1/cart';
                    try {
                        global $woocommerce;
                        $url = add_query_arg($woocommerce->query_string, '', home_url($woocommerce->request)) . "?rest_route=/salesmanago/v1/cart";
                    } catch (\Exception $e) {
                        MessageEntity::getInstance()->addException(new Exception($e->getMessage(), 655));
                    }
                    ?>
                    <button class="button-secondary" onclick="salesmanagoTestCartRecovery('<?=$url?>'); return false;"><?php _e('Test REST routes and functions', 'salesmanago') ?></button>
                    <label for="salesmanago-prevent-event-duplication">
                        <p class="description">
                            <?php _e('Test REST API to debug cart recovery links.', 'salesmanago') ?>                            </p>
                    </label>
                </td>
            </tr>
            <tr valign="top" id="salesmanago-cart-recovery-test" style="display: none">
                <th scope="row" class="titledesc">
                    <label><?php _e('Results', 'salesmanago') ?></label>
                </th>
                <td id="salesmanago-cart-recovery-test-content">

                </td>
            </tr>
        </table>
        <?php
            include(dirname(__FILE__).'/../partials/save.php');
        ?>
    </form>
</div>
<script>
    window.salesmanago.translations = {
        urlNotFound:   ' <?php _e('returned status:', 'salesmanago')?>',
        problem:       ' <?php _e('Problem', 'salesmanago')?>',

    };
</script>